/*
 * kbhit.c
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <sys/select.h>

#include "kbhit.h"

int kbhit(void)
{
    fd_set set;
    struct timeval timeout;
    int ret;

    FD_ZERO(&set);
    FD_SET(STDIN_FILENO, &set);

    timeout.tv_sec = 0;
    timeout.tv_usec = 0;

    do {
        ret = select(FD_SETSIZE, &set, NULL, NULL, &timeout);
    } while (ret < 0 && errno == EINTR);
    if (ret < 0) {
        perror("select");
        exit(1);
    }

    return ret;
}
