#!/usr/bin/perl

use strict;
use warnings;

my $video_dev = $ARGV[0];
my $cfg_file = $ARGV[1];
my $siusbctl = $ARGV[2];
my $sisnap = $ARGV[3];
my $iters = $ARGV[4];

die "required params: video_dev cfg_file siusbctl sisnap iters\n" unless $#ARGV + 1 == 5;

my $command;
my $i;

# set unusal parameters, should be different from the config file
system("$siusbctl --clock=60 --shutter-mode=ROLLING --exposure=0 --gain=10.69 --black-level=127 --black-balance=127 --trig-mode=0 $video_dev");

open(CFG, $cfg_file);
while(<CFG>)
{
  chomp;
  $command = "$siusbctl --$_ $video_dev\n";
  # print $command;
  system($command);
  $i = $iters;
  $command = "$sisnap $video_dev 256 256\n";
  while($i-- > 0)
  {
    # print $command;
    system($command);
  }
}
