/*
 * dead.c
 *
 */

#include "dead.h"

unsigned char bufAverage(const unsigned char *buf, unsigned size)
{
    unsigned sum = 0;
    unsigned i;

    for (i = 0; i < size; i++)
        sum += buf[i];
    return sum / size;
}

int bufFindDeviant(const unsigned char *buf, unsigned size, unsigned *idx,
                   unsigned char min_val, unsigned char max_val)
{
    unsigned i;

    for (i = *idx; i < size; i++) {
        if (buf[i] < min_val || buf[i] > max_val) {
            *idx = i;
            return 1;
        }
    }
    return 0;
}
