/*
 * savepgm.c
 *
 */

#include <stdlib.h>
#include <stdio.h>

#include "savepgm.h"

void save_pgm(const char *fname, const char *buf, int width, int height)
{
    FILE *fp;

    fp = fopen(fname, "w");
    if (!fp) {
        perror("fopen");
        exit(1);
    }

    fprintf(fp, "P5\n%d %d\n255\n", width, height);

    if (fwrite(buf, width*height, 1, fp) != 1) {
        perror("fwrite");
        exit(1);
    }

    fclose(fp);
}
