/*
 * sicam.h
 *
 */

#ifndef SICAM_H
#define SICAM_H

#include "siusb.h"
#include "cam.h"

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned sicam_get_clock(struct cam *c);
extern int sicam_set_clock(struct cam *c, unsigned v);

extern unsigned sicam_get_shutter_mode(struct cam *c);
extern int sicam_set_shutter_mode(struct cam *c, unsigned v);

extern unsigned sicam_get_exposure(struct cam *c);
extern int sicam_set_exposure(struct cam *c, unsigned v);

extern unsigned sicam_get_gain(struct cam *c);
extern int sicam_set_gain(struct cam *c, unsigned v);

extern unsigned sicam_get_black_level(struct cam *c);
extern int sicam_set_black_level(struct cam *c, unsigned v);

extern unsigned sicam_get_black_balance(struct cam *c);
extern int sicam_set_black_balance(struct cam *c, unsigned v);

extern unsigned sicam_get_trig_mode(struct cam *c);
extern void sicam_set_trig_mode(struct cam *c, unsigned v);

#ifdef __cplusplus
}
#endif

#endif /* SICAM_H */
